Index: branches/ODCCP/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp
===================================================================
--- branches/ODCCP/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp	(revision 492)
+++ branches/ODCCP/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp	(revision 494)
@@ -3881,31 +4055,46 @@
   ////////////////////////////////////////////////////////////////////////////
   // The IXR_RSP FSM receives the response packets from the XRAM,
-  // for both put transaction, and get transaction.
+  // for both PUT transaction, and GET transaction.
   //
-  // - A response to a put request is a single-cell VCI packet.
-  // The Transaction Tab index is contained in the RTRDID field.
+  // - A response to a PUT request is a single-cell VCI packet.
+  // The TRT index is contained in the RTRDID field.
   // The FSM takes the lock protecting the TRT, and the corresponding
-  // entry is erased.
+  // entry is erased. If an acknowledge was required (in case of software SYNC)
+  // the r_config_rsp_lines counter is decremented.  
   //
-  // - A response to a get request is a multi-cell VCI packet.
-  // The Transaction Tab index is contained in the RTRDID field.
+  // - A response to a GET request is a multi-cell VCI packet.
+  // The TRT index is contained in the RTRDID field.
   // The N cells contain the N words of the cache line in the RDATA field.
   // The FSM takes the lock protecting the TRT to store the line in the TRT
   // (taking into account the write requests already stored in the TRT).
-  // When the line is completely written, the corresponding rok signal is set.
+  // When the line is completely written, the r_ixr_rsp_to_xram_rsp_rok[index]  
+  // signal is set to inform the XRAM_RSP FSM.
   ///////////////////////////////////////////////////////////////////////////////
+
+//std::cout << std::endl << "ixr_rsp_fsm" << std::endl;
 
   switch(r_ixr_rsp_fsm.read())
   {
-    //////////////////
-    case IXR_RSP_IDLE:  // test transaction type: PUT/GET
-    {
-      if(p_vci_ixr.rspval.read())
-      {
-        r_ixr_rsp_cpt   = 0;
-        r_ixr_rsp_trt_index = p_vci_ixr.rtrdid.read();
-        if(p_vci_ixr.reop.read() and !(p_vci_ixr.rerror.read() &0x1))   // PUT transaction
-        {
-          r_ixr_rsp_fsm = IXR_RSP_ACK;
+      //////////////////
+      case IXR_RSP_IDLE:  // test transaction type: PUT/GET
+      {
+          if(p_vci_ixr.rspval.read())
+          {
+              r_ixr_rsp_cpt       = 0;
+              r_ixr_rsp_trt_index = p_vci_ixr.rtrdid.read();
+
+              assert( ((p_vci_ixr.rerror.read() & 0x1) == 0) and
+              "MEMC ERROR in IXR_RSP state: XRAM response error !");
+
+              if(p_vci_ixr.reop.read())   // PUT
+              {
+#if ODCCP_NON_INCLUSIVE
+                  if (p_vci_ixr.rtrdid.read() == m_trt_lines)
+                    r_ixr_rsp_fsm = IXR_RSP_ACK;
+                  else
+                    r_ixr_rsp_fsm = IXR_RSP_TRT_ERASE;
+#else
+                  r_ixr_rsp_fsm = IXR_RSP_TRT_ERASE;
+#endif
 
 #if DEBUG_MEMC_IXR_RSP
@@ -3914,8 +4103,8 @@
           << " IXR_RSP_IDLE> Response from XRAM to a put transaction" << std::endl;
 #endif
-        }
-        else                                                         // GET transaction
-        {
-          r_ixr_rsp_fsm = IXR_RSP_TRT_READ;
+              }
+              else                       // GET 
+              {
+                  r_ixr_rsp_fsm = IXR_RSP_TRT_READ;
 
 #if DEBUG_MEMC_IXR_RSP
@@ -3924,36 +4113,24 @@
           << " IXR_RSP_IDLE> Response from XRAM to a get transaction" << std::endl;
 #endif
-        }
-      }
-      break;
-    }
-    /////////////////
-    case IXR_RSP_ACK:        // Aknowledge the VCI response for a PUT
-    {
-#if ODCCP_NON_INCLUSIVE
-      if(p_vci_ixr.rspval.read())
-      {
-        if (r_ixr_rsp_trt_index.read() == m_trt_lines)
-          r_ixr_rsp_fsm = IXR_RSP_IDLE;
-        else
-          r_ixr_rsp_fsm = IXR_RSP_TRT_ERASE;
-      }
-#else
-      if(p_vci_ixr.rspval.read()) r_ixr_rsp_fsm = IXR_RSP_TRT_ERASE;
-#endif
-
-#if DEBUG_MEMC_IXR_RSP
-if(m_debug)
-std::cout << "  <MEMC " << name() << " IXR_RSP_ACK>" << std::endl;
-#endif
-      break;
-    }
-    ////////////////////////
-    case IXR_RSP_TRT_ERASE:   // erase the entry in the TRT
-    {
-      if(r_alloc_trt_fsm.read() == ALLOC_TRT_IXR_RSP)
-      {
-        m_trt.erase(r_ixr_rsp_trt_index.read());
+              }
+          }
+          break;
+      }
+      ////////////////////////
+      case IXR_RSP_ACK:     // Acknowledge PUT transaction
+      {
         r_ixr_rsp_fsm = IXR_RSP_IDLE;
+        break;
+      }
+      ////////////////////////
+      case IXR_RSP_TRT_ERASE:   // erase the entry in the TRT
+                                // decrease the line counter if config request
+      {
+          if(r_alloc_trt_fsm.read() == ALLOC_TRT_IXR_RSP)
+          {
+              size_t  index = r_ixr_rsp_trt_index.read(); 
+              if (m_trt.is_config(index) ) r_config_rsp_lines = r_config_rsp_lines.read() - 1;
+              m_trt.erase(index);
+              r_ixr_rsp_fsm = IXR_RSP_IDLE;
 
 #if DEBUG_MEMC_IXR_RSP
@@ -3962,53 +4139,47 @@
           << r_ixr_rsp_trt_index.read() << std::endl;
 #endif
-      m_cpt_ixr_fsm_n_trt_lock++;
-      }
-
-      m_cpt_ixr_fsm_trt_lock++;
-
-      break;
-    }
-    //////////////////////
-    case IXR_RSP_TRT_READ:    // write a 64 bits data in the TRT
-    {
-      if((r_alloc_trt_fsm.read() == ALLOC_TRT_IXR_RSP) and  p_vci_ixr.rspval)
-      {
-        size_t      index    = r_ixr_rsp_trt_index.read();
-        bool        eop      = p_vci_ixr.reop.read();
-        wide_data_t data     = p_vci_ixr.rdata.read();
-        bool        error    = ((p_vci_ixr.rerror.read() & 0x1) == 1);
-
-        assert(((eop == (r_ixr_rsp_cpt.read() == (m_words-2))) or p_vci_ixr.rerror.read())
-               and "Error in VCI_MEM_CACHE : invalid length for a response from XRAM");
-
-        m_trt.write_rsp( index,
-                         r_ixr_rsp_cpt.read(),
-                         data,
-                         error);
-
-        r_ixr_rsp_cpt = r_ixr_rsp_cpt.read() + 2;
-
-        if(eop)
-        {
-          r_ixr_rsp_to_xram_rsp_rok[r_ixr_rsp_trt_index.read()]=true;
-          /*if(p_vci_ixr.rpktid.read()&0xF == 0x9)
-            r_ixr_rsp_to_xram_rsp_no_coherent[r_ixr_rsp_trt_index.read()] = true;
-          else
-            r_ixr_rsp_to_xram_rsp_no_coherent[r_ixr_rsp_trt_index.read()] = false;*/
-          r_ixr_rsp_fsm = IXR_RSP_IDLE;
-        }
+          }
+          break;
+      }
+      //////////////////////
+      case IXR_RSP_TRT_READ:    // write a 64 bits data word in TRT
+      {
+          if((r_alloc_trt_fsm.read() == ALLOC_TRT_IXR_RSP) and  p_vci_ixr.rspval)
+          {
+              size_t      index    = r_ixr_rsp_trt_index.read();
+              size_t      word     = r_ixr_rsp_cpt.read();
+              bool        eop      = p_vci_ixr.reop.read();
+              wide_data_t data     = p_vci_ixr.rdata.read();
+              bool        error    = ((p_vci_ixr.rerror.read() & 0x1) == 1);
+
+              assert(((eop == (word == (m_words-2))) or error) and
+              "MEMC ERROR in IXR_RSP_TRT_READ state : invalid response from XRAM");
+
+              m_trt.write_rsp( index,
+                               word,
+                               data );
+
+              r_ixr_rsp_cpt = word + 2;
+
+              if(eop)
+              {
+                r_ixr_rsp_to_xram_rsp_rok[r_ixr_rsp_trt_index.read()]=true;
+                /*if(p_vci_ixr.rpktid.read()&0xF == 0x9)
+                  r_ixr_rsp_to_xram_rsp_no_coherent[r_ixr_rsp_trt_index.read()] = true;
+                  else
+                  r_ixr_rsp_to_xram_rsp_no_coherent[r_ixr_rsp_trt_index.read()] = false;*/
+                r_ixr_rsp_fsm = IXR_RSP_IDLE;
+              }
 
 #if DEBUG_MEMC_IXR_RSP
 if(m_debug)
-std::cout << "  <MEMC " << name() << " IXR_RSP_TRT_READ> Writing a word in TRT : "
+std::cout << "  <MEMC " << name() << " IXR_RSP_TRT_READ> Writing 2 words in TRT : "
           << " index = " << std::dec << index
-          << " / word = " << r_ixr_rsp_cpt.read()
+          << " / word = " << word
           << " / data = " << std::hex << data << std::endl;
 #endif
-      m_cpt_ixr_fsm_n_trt_lock++;
-      }
-      m_cpt_ixr_fsm_trt_lock++;
-      break;
-    }
+          }
+          break;
+      }
   } // end swich r_ixr_rsp_fsm
 
@@ -4016,15 +4187,15 @@
   //                XRAM_RSP FSM
   ////////////////////////////////////////////////////////////////////////////
-  // The XRAM_RSP FSM handles the incoming cache lines from the XRAM.
+  // The XRAM_RSP FSM handles the incoming cache lines after an XRAM GET.
   // The cache line has been written in the TRT by the IXR_CMD_FSM.
   // As the IXR_RSP FSM and the XRAM_RSP FSM are running in parallel,
-  // there is as many flip-flops r_ixr_rsp_to_xram_rsp_rok[i]
-  // as the number of entries in the TRT, that are handled with
-  // a round-robin priority...
+  // there is as many flip-flops r_ixr_rsp_to_xram_rsp_rok[i] as the number 
+  // of entries in the TRT, that are handled with a round-robin priority...
   //
-  // When a response is available, the corresponding TRT entry
-  // is copied in a local buffer to be written in the cache.
-  // The FSM takes the lock protecting the TRT, and the lock protecting the DIR.
-  // It selects a cache slot and writes the line in the cache.
+  // The FSM takes the lock protecting TRT, and the lock protecting DIR.
+  // The selected TRT entry is copied in the local buffer r_xram_rsp_trt_buf.
+  // It selects a cache slot and save the victim line in another local buffer
+  // r_xram_rsp_victim_***.
+  // It writes the line extracted from TRT in the cache.
   // If it was a read MISS, the XRAM_RSP FSM send a request to the TGT_RSP
   // FSM to return the cache line to the registered processor.
@@ -4036,4 +4207,6 @@
   ///////////////////////////////////////////////////////////////////////////////
 
+//std::cout << std::endl << "xram_rsp_fsm" << std::endl;
+
   switch(r_xram_rsp_fsm.read())
   {
@@ -4041,15 +4214,14 @@
     case XRAM_RSP_IDLE: // scan the XRAM responses / select a TRT index (round robin)
     {
-      size_t ptr   = r_xram_rsp_trt_index.read();
-      size_t lines = m_trt_lines;
-      
-      for(size_t i=0 ; i<lines ; i++)
-      {
-        size_t index = (i+ptr+1) %lines;
-        if(r_ixr_rsp_to_xram_rsp_rok[index])
-        {
-          r_xram_rsp_trt_index             = index;
-          r_ixr_rsp_to_xram_rsp_rok[index] = false;
-          r_xram_rsp_fsm                   = XRAM_RSP_DIR_LOCK;
+        size_t old   = r_xram_rsp_trt_index.read();
+        size_t lines = m_trt_lines;
+        for(size_t i=0 ; i<lines ; i++)
+        {
+            size_t index = (i+old+1) %lines;
+            if(r_ixr_rsp_to_xram_rsp_rok[index])
+            {
+                r_xram_rsp_trt_index             = index;
+                r_ixr_rsp_to_xram_rsp_rok[index] = false;
+                r_xram_rsp_fsm                   = XRAM_RSP_DIR_LOCK;
 
 #if DEBUG_MEMC_XRAM_RSP
@@ -4059,8 +4231,8 @@
           << " index = " << std::dec << index << std::endl;
 #endif
-          break;
-        }
-      }
-      break;
+                break;
+            }
+        }
+        break;
     }
     ///////////////////////
@@ -4068,12 +4240,11 @@
                             // Copy the TRT entry in a local buffer
     {
-      if((r_alloc_dir_fsm.read() == ALLOC_DIR_XRAM_RSP) and
-          (r_alloc_trt_fsm.read() == ALLOC_TRT_XRAM_RSP))
-      {
-        // copy the TRT entry in the r_xram_rsp_trt_buf local buffer
-        size_t  index = r_xram_rsp_trt_index.read();
-        r_xram_rsp_trt_buf.copy( m_trt.read(index) );
-
-        r_xram_rsp_fsm = XRAM_RSP_TRT_COPY;
+        if( (r_alloc_dir_fsm.read() == ALLOC_DIR_XRAM_RSP) and
+            (r_alloc_trt_fsm.read() == ALLOC_TRT_XRAM_RSP) )
+        {
+            // copy the TRT entry in the r_xram_rsp_trt_buf local buffer
+            size_t  index = r_xram_rsp_trt_index.read();
+            r_xram_rsp_trt_buf.copy( m_trt.read(index) );
+            r_xram_rsp_fsm = XRAM_RSP_TRT_COPY;
 
 #if DEBUG_MEMC_XRAM_RSP
@@ -4082,10 +4253,6 @@
           << " Get access to DIR and TRT" << std::endl;
 #endif
-        m_cpt_xram_rsp_fsm_n_dir_lock++;
-        m_cpt_xram_rsp_fsm_n_trt_lock++;
-      }
-      m_cpt_xram_rsp_fsm_dir_lock++;
-      m_cpt_xram_rsp_fsm_trt_lock++;
-      break;
+        }
+        break;
     }
     ///////////////////////
@@ -4093,7 +4260,10 @@
                             // and copy it in a local buffer
     {
-      if ( (r_alloc_trt_fsm.read() == ALLOC_TRT_XRAM_RSP) and
-           (r_alloc_dir_fsm.read() == ALLOC_DIR_XRAM_RSP) )
-      {
+        assert( (r_alloc_dir_fsm.read() == ALLOC_DIR_XRAM_RSP) and
+        "MEMC ERROR in XRAM_RSP_TRT_COPY state: Bad DIR allocation");
+
+        assert( (r_alloc_trt_fsm.read() == ALLOC_TRT_XRAM_RSP) and
+        "MEMC ERROR in XRAM_RSP_TRT_COPY state: Bad TRT allocation");
+
         // selects & extracts a victim line from cache
         size_t way = 0;
@@ -4108,12 +4278,8 @@
 #endif
 
-        // copy the victim line in a local buffer
+        // copy the victim line in a local buffer (both data dir)
         m_cache_data.read_line(way, set, r_xram_rsp_victim_data);
 
         r_xram_rsp_victim_copy      = victim.owner.srcid;
-
-#if L1_MULTI_CACHE
-        r_xram_rsp_victim_copy_cache= victim.owner.cache_id;
-#endif
         
         r_xram_rsp_victim_coherent  = victim.coherent;
@@ -4128,30 +4294,11 @@
         r_xram_rsp_victim_dirty     = victim.dirty;
 
-
-        if(!r_xram_rsp_trt_buf.rerror)
-        {
-#if ODCCP_NON_INCLUSIVE
-          r_xram_rsp_fsm = XRAM_RSP_INVAL_LOCK;
-#else
-          /*ODCCP*/ //if victim is no coherent and there is an inval no coherent pending we wait
-          /*if(!victim.coherent and r_xram_rsp_to_ixr_cmd_inval_ncc_pending.read())
-          {
-            r_xram_rsp_fsm = XRAM_RSP_INVAL_WAIT;
-          }
-          else
-          {*/
-            r_xram_rsp_fsm = XRAM_RSP_INVAL_LOCK;
-         //}
-#endif
-        }
-        else
-        {
-          r_xram_rsp_fsm = XRAM_RSP_ERROR_ERASE;
-        }
+        if( not r_xram_rsp_trt_buf.rerror ) r_xram_rsp_fsm = XRAM_RSP_IVT_LOCK;
+        else                                r_xram_rsp_fsm = XRAM_RSP_ERROR_ERASE;
 
 #if DEBUG_MEMC_XRAM_RSP
 if(m_debug)
 std::cout << "  <MEMC " << name() << " XRAM_RSP_TRT_COPY>"
-          << " Select a slot: "
+          << " Select a victim slot: "
           << " way = " << std::dec << way
           << " / set = " << set
@@ -4160,58 +4307,54 @@
           << " / inval_required = " << inval << std::endl;
 #endif
-      }
-      else
-      {
-        std::cout << "VCI_MEM_CACHE ERROR " << name() << " XRAM_RSP_TRT_COPY"
-                  << " bad TRT or DIR allocation" << std::endl;
-        exit(0);
-      }
-      break;
-    }
-    /////////////////////////
-    case XRAM_RSP_INVAL_LOCK: // Take the IVT lock to check a possible pending inval
-    {
-      if(r_alloc_ivt_fsm == ALLOC_IVT_XRAM_RSP)
-      {
-        size_t index = 0;
-        if(m_ivt.search_inval(r_xram_rsp_trt_buf.nline, index))  // pending inval
-        {
-          r_xram_rsp_fsm = XRAM_RSP_INVAL_WAIT;
+        break;
+    }
+    ///////////////////////
+    case XRAM_RSP_IVT_LOCK:   // Keep DIR and TRT locks and take the IVT lock 
+                              // to check a possible pending inval
+    {
+        assert( (r_alloc_dir_fsm.read() == ALLOC_DIR_XRAM_RSP) and
+        "MEMC ERROR in XRAM_RSP_IVT_LOCK state: Bad DIR allocation");
+
+        assert( (r_alloc_trt_fsm.read() == ALLOC_TRT_XRAM_RSP) and
+        "MEMC ERROR in XRAM_RSP_IVT_LOCK state: Bad TRT allocation");
+
+        if(r_alloc_ivt_fsm == ALLOC_IVT_XRAM_RSP)
+        {
+            size_t index = 0;
+            if(m_ivt.search_inval(r_xram_rsp_trt_buf.nline, index))  // pending inval
+            {
+                r_xram_rsp_fsm = XRAM_RSP_INVAL_WAIT;
 
 #if DEBUG_MEMC_XRAM_RSP
 if(m_debug)
-std::cout << "  <MEMC " << name() << " XRAM_RSP_INVAL_LOCK>"
+std::cout << "  <MEMC " << name() << " XRAM_RSP_IVT_LOCK>"
           << " Get acces to IVT, but line invalidation registered"
-          << " / nline = " << std::hex << r_xram_rsp_trt_buf.nline
+          << " / address = " << std::hex << r_xram_rsp_trt_buf.nline*m_words*4
           << " / index = " << std::dec << index << std::endl;
 #endif
 
-        }
-        else if(m_ivt.is_full() and r_xram_rsp_victim_inval.read()) // IVT full
-        {
-          r_xram_rsp_fsm = XRAM_RSP_INVAL_WAIT;
+            }
+            else if(m_ivt.is_full() and r_xram_rsp_victim_inval.read()) // IVT full
+            {
+                r_xram_rsp_fsm = XRAM_RSP_INVAL_WAIT;
 
 #if DEBUG_MEMC_XRAM_RSP
 if(m_debug)
-std::cout << "  <MEMC " << name() << " XRAM_RSP_INVAL_LOCK>"
+std::cout << "  <MEMC " << name() << " XRAM_RSP_IVT_LOCK>"
           << " Get acces to IVT, but inval required and IVT full" << std::endl;
 #endif
-        }
-        else
-        {
-          r_xram_rsp_fsm = XRAM_RSP_DIR_UPDT;
+            }
+            else
+            {
+                r_xram_rsp_fsm = XRAM_RSP_DIR_UPDT;
 
 #if DEBUG_MEMC_XRAM_RSP
 if(m_debug)
-std::cout << "  <MEMC " << name() << " XRAM_RSP_INVAL_LOCK>"
-          << " Get acces to IVT" << std::endl;
-#endif
-        }
-        m_cpt_xram_rsp_fsm_n_upt_lock++;
-      }
-
-      m_cpt_xram_rsp_fsm_upt_lock++;
-
-      break;
+std::cout << "  <MEMC " << name() << " XRAM_RSP_IVT_LOCK>"
+          << " Get acces to IVT / no pending inval request" << std::endl;
+#endif
+            }
+        }
+        break;
     }
     /////////////////////////
@@ -4224,38 +4367,42 @@
           << " Release all locks and retry" << std::endl;
 #endif
-      r_xram_rsp_fsm = XRAM_RSP_DIR_LOCK;
-      break;
+        r_xram_rsp_fsm = XRAM_RSP_DIR_LOCK;
+        break;
     }
     ///////////////////////
-    case XRAM_RSP_DIR_UPDT:   // updates the cache (both data & directory)
-                              // and possibly set an inval request in IVT
-    {
-      // check if this is an instruction read, this means pktid is either
-      // TYPE_READ_INS_UNC   0bX010 with TSAR encoding
-      // TYPE_READ_INS_MISS  0bX011 with TSAR encoding
-      bool inst_read = (r_xram_rsp_trt_buf.pktid & 0x2) and r_xram_rsp_trt_buf.proc_read;
-
-      // check if this is a cached read, this means pktid is either
-      // TYPE_READ_DATA_MISS 0bX001 with TSAR encoding
-      // TYPE_READ_INS_MISS  0bX011 with TSAR encoding
-      bool cached_read = (r_xram_rsp_trt_buf.pktid & 0x1) and r_xram_rsp_trt_buf.proc_read;
-
-      bool dirty = false;
-
-      // update cache data
-      size_t set   = r_xram_rsp_victim_set.read();
-      size_t way   = r_xram_rsp_victim_way.read();
-      for(size_t word=0; word<m_words ; word++)
-      {
-        m_cache_data.write(way, set, word, r_xram_rsp_trt_buf.wdata[word]);
-
-        dirty = dirty or (r_xram_rsp_trt_buf.wdata_be[word] != 0);
-
-        if(m_monitor_ok)
-        {
-          addr_t address = r_xram_rsp_trt_buf.nline<<6 | word<<2;
-          check_monitor( address, r_xram_rsp_trt_buf.wdata[word], false);
-        }
-      }
+    case XRAM_RSP_DIR_UPDT:   // updates the cache (both data & directory),
+                              // erases the TRT entry if victim not dirty,
+                              // and set inval request in IVT if required
+    {
+        assert( (r_alloc_dir_fsm.read() == ALLOC_DIR_XRAM_RSP) and
+        "MEMC ERROR in XRAM_RSP_DIR_UPDT state: Bad DIR allocation");
+
+        assert( (r_alloc_trt_fsm.read() == ALLOC_TRT_XRAM_RSP) and
+        "MEMC ERROR in XRAM_RSP_DIR_UPDT state: Bad TRT allocation");
+
+        assert( (r_alloc_ivt_fsm.read() == ALLOC_IVT_XRAM_RSP) and
+        "MEMC ERROR in XRAM_RSP_DIR_UPDT state: Bad IVT allocation");
+
+        // check if this is an instruction read, this means pktid is either
+        // TYPE_READ_INS_UNC   0bX010 with TSAR encoding
+        // TYPE_READ_INS_MISS  0bX011 with TSAR encoding
+        bool inst_read = (r_xram_rsp_trt_buf.pktid & 0x2) and r_xram_rsp_trt_buf.proc_read;
+
+        // check if this is a cached read, this means pktid is either
+        // TYPE_READ_DATA_MISS 0bX001 with TSAR encoding
+        // TYPE_READ_INS_MISS  0bX011 with TSAR encoding
+        bool cached_read = (r_xram_rsp_trt_buf.pktid & 0x1) and r_xram_rsp_trt_buf.proc_read;
+
+        bool dirty = false;
+
+        // update cache data
+        size_t set   = r_xram_rsp_victim_set.read();
+        size_t way   = r_xram_rsp_victim_way.read();
+
+        for(size_t word=0; word<m_words ; word++)
+        {
+            m_cache_data.write(way, set, word, r_xram_rsp_trt_buf.wdata[word]);
+            dirty = dirty or (r_xram_rsp_trt_buf.wdata_be[word] != 0);
+        }
 
       // update cache directory
@@ -4297,31 +4444,27 @@
       m_cache_directory.write(set, way, entry);
 
-      // request an invalidation request in IVT for victim line
-      if(r_xram_rsp_victim_inval.read())
-      {
-        bool   broadcast    = r_xram_rsp_victim_is_cnt.read();
-        size_t index        = 0;
-        size_t count_copies = r_xram_rsp_victim_count.read();
+        // register invalid request in IVT for victim line if required
+        if(r_xram_rsp_victim_inval.read())
+        {
+            bool   broadcast    = r_xram_rsp_victim_is_cnt.read();
+            size_t index        = 0;
+            size_t count_copies = r_xram_rsp_victim_count.read();
         
-        bool   wok = m_ivt.set(false,      // it's an inval transaction
-                               broadcast,  // set broadcast bit
-                               false,      // no response required 
-                               false,      // no acknowledge required 
-                               0,          // srcid
-                               0,          // trdid
-                               0,          // pktid
-                               r_xram_rsp_victim_nline.read(),
-                               count_copies,
-                               index);
-
-        r_xram_rsp_ivt_index = index;
-
-        if(!wok)
-        {
-          std::cout << "VCI_MEM_CACHE ERROR " << name() << " XRAM_RSP_DIR_UPDT"
-                    << " invalidate_tab entry free but write unsuccessful" << std::endl;
-          exit(0);
-        }
-      }
+            bool   wok = m_ivt.set(false,      // it's an inval transaction
+                                   broadcast,  // set broadcast bit
+                                   false,      // no response required 
+                                   false,      // no acknowledge required 
+                                   0,          // srcid
+                                   0,          // trdid
+                                   0,          // pktid
+                                   r_xram_rsp_victim_nline.read(),
+                                   count_copies,
+                                   index);
+
+            r_xram_rsp_ivt_index = index;
+
+            assert( wok and
+            "MEMC ERROR in XRAM_RSP_DIR_UPDT state: IVT should not be full"); 
+        }
 
 #if DEBUG_MEMC_XRAM_RSP
@@ -4337,6 +4480,6 @@
           << " / is_cnt = " << entry.is_cnt << std::endl;
 if(r_xram_rsp_victim_inval.read())
-std::cout << "                           Invalidation request for victim line "
-          << std::hex << r_xram_rsp_victim_nline.read()
+std::cout << "                           Invalidation request for address "
+          << std::hex << r_xram_rsp_victim_nline.read()*m_words*4
           << " / broadcast = " << r_xram_rsp_victim_is_cnt.read() << std::endl;
 }
@@ -4367,36 +4510,23 @@
     case XRAM_RSP_TRT_DIRTY:  // set the TRT entry (PUT to XRAM) if the victim is dirty
     {
-      if(r_alloc_trt_fsm.read() == ALLOC_TRT_XRAM_RSP)
-      {
-        std::vector<data_t> data_vector;
-        data_vector.clear();
-        
-        for(size_t i=0; i<m_words; i++)
-        {
-          data_vector.push_back(r_xram_rsp_victim_data[i]);
-        }
-        /*m_trt.set(r_xram_rsp_trt_index.read(),
-                              false,       // write to XRAM
-                              r_xram_rsp_victim_nline.read(),  // line index
-                              0,
-                              0,
-                              0,
-                              false,
-                              0,
-                              0,
-                              std::vector<be_t> (m_words,0),
-                              std::vector<data_t> (m_words,0));*/
-        
-        m_trt.set(r_xram_rsp_trt_index.read(),
-                  false,       // write to XRAM
-                  r_xram_rsp_victim_nline.read(),  // line index
-                  0,
-                  0,
-                  0,
-                  false,
-                  0,
-                  0,
-                  std::vector<be_t> (m_words,0),
-                  data_vector);
+        if(r_alloc_trt_fsm.read() == ALLOC_TRT_XRAM_RSP)
+        {
+            std::vector<data_t> data_vector;
+            data_vector.clear();
+            for(size_t i=0; i<m_words; i++)
+            {
+                data_vector.push_back(r_xram_rsp_victim_data[i].read());
+            }
+            m_trt.set( r_xram_rsp_trt_index.read(),
+                       false,                             // PUT
+                       r_xram_rsp_victim_nline.read(),    // line index
+                       0,                                 // unused
+                       0,                                 // unused
+                       0,                                 // unused
+                       false,                             // not proc_read
+                       0,                                 // unused
+                       0,                                 // unused
+                       std::vector<be_t>(m_words,0xF),                         
+                       data_vector);
 
 #if DEBUG_MEMC_XRAM_RSP
@@ -4404,33 +4534,29 @@
 std::cout << "  <MEMC " << name() << " XRAM_RSP_TRT_DIRTY>"
           << " Set TRT entry for the put transaction"
-          << " / dirty victim line = " << r_xram_rsp_victim_nline.read() << std::endl;
-#endif
-        if(r_xram_rsp_trt_buf.proc_read)         r_xram_rsp_fsm = XRAM_RSP_DIR_RSP;
-        else if(r_xram_rsp_victim_inval.read())  r_xram_rsp_fsm = XRAM_RSP_INVAL;
-        else                                     r_xram_rsp_fsm = XRAM_RSP_WRITE_DIRTY;
-        m_cpt_xram_rsp_fsm_n_trt_lock++;
-      }
-
-      m_cpt_xram_rsp_fsm_trt_lock++;
-
-      break;
+          << " / address = " << (r_xram_rsp_victim_nline.read()*m_words*4) << std::endl;
+#endif
+            if(r_xram_rsp_trt_buf.proc_read)         r_xram_rsp_fsm = XRAM_RSP_DIR_RSP;
+            else if(r_xram_rsp_victim_inval.read())  r_xram_rsp_fsm = XRAM_RSP_INVAL;
+            else                                     r_xram_rsp_fsm = XRAM_RSP_WRITE_DIRTY;
+        }
+        break;
     }
     //////////////////////
     case XRAM_RSP_DIR_RSP:     // Request a response to TGT_RSP FSM
     {
-      if(!r_xram_rsp_to_tgt_rsp_req.read())
-      {
-        r_xram_rsp_to_tgt_rsp_srcid = r_xram_rsp_trt_buf.srcid;
-        r_xram_rsp_to_tgt_rsp_trdid = r_xram_rsp_trt_buf.trdid;
-        r_xram_rsp_to_tgt_rsp_pktid = r_xram_rsp_trt_buf.pktid;
-        for(size_t i=0; i < m_words; i++)
-        {
-            r_xram_rsp_to_tgt_rsp_data[i] = r_xram_rsp_trt_buf.wdata[i];
-        }
-        r_xram_rsp_to_tgt_rsp_word   = r_xram_rsp_trt_buf.word_index;
-        r_xram_rsp_to_tgt_rsp_length = r_xram_rsp_trt_buf.read_length;
-        r_xram_rsp_to_tgt_rsp_ll_key = r_xram_rsp_trt_buf.ll_key;
-        r_xram_rsp_to_tgt_rsp_rerror = false;
-        r_xram_rsp_to_tgt_rsp_req    = true;
+        if ( not r_xram_rsp_to_tgt_rsp_req.read() )
+        {
+            r_xram_rsp_to_tgt_rsp_srcid = r_xram_rsp_trt_buf.srcid;
+            r_xram_rsp_to_tgt_rsp_trdid = r_xram_rsp_trt_buf.trdid;
+            r_xram_rsp_to_tgt_rsp_pktid = r_xram_rsp_trt_buf.pktid;
+            for(size_t i=0; i < m_words; i++)
+            {
+                r_xram_rsp_to_tgt_rsp_data[i] = r_xram_rsp_trt_buf.wdata[i];
+            }
+            r_xram_rsp_to_tgt_rsp_word   = r_xram_rsp_trt_buf.word_index;
+            r_xram_rsp_to_tgt_rsp_length = r_xram_rsp_trt_buf.read_length;
+            r_xram_rsp_to_tgt_rsp_ll_key = r_xram_rsp_trt_buf.ll_key;
+            r_xram_rsp_to_tgt_rsp_rerror = false;
+            r_xram_rsp_to_tgt_rsp_req    = true;
 
 #if ODCCP_NON_INCLUSIVE
@@ -4454,6 +4580,6 @@
           << " / nwords = " << std::dec << r_xram_rsp_trt_buf.read_length << std::endl;
 #endif
-      }
-      break;
+        }
+        break;
     }
     ////////////////////
@@ -4473,9 +4599,6 @@
         xram_rsp_to_cc_send_fifo_srcid     = r_xram_rsp_victim_copy.read();
         xram_rsp_to_cc_send_fifo_inst      = r_xram_rsp_victim_copy_inst.read();
-#if L1_MULTI_CACHE
-        xram_rsp_to_cc_send_fifo_cache_id  = r_xram_rsp_victim_copy_cache.read();
-#endif
         xram_rsp_to_cc_send_fifo_put       = multi_req;
-        r_xram_rsp_next_ptr                 = r_xram_rsp_victim_ptr.read();
+        r_xram_rsp_next_ptr                = r_xram_rsp_victim_ptr.read();
 
 #if ODCCP_NON_INCLUSIVE
@@ -4494,5 +4617,5 @@
 std::cout << "  <MEMC " << name() << " XRAM_RSP_INVAL>"
           << " Send an inval request to CC_SEND FSM"
-          << " / victim line = " << r_xram_rsp_victim_nline.read() << std::endl;
+          << " / address = " << r_xram_rsp_victim_nline.read()*m_words*4 << std::endl;
 #endif
       }
@@ -4506,12 +4629,10 @@
 
         r_xram_rsp_to_ixr_cmd_req = true;
-        r_xram_rsp_to_ixr_cmd_nline = r_xram_rsp_victim_nline.read();
-        r_xram_rsp_to_ixr_cmd_trdid = r_xram_rsp_trt_index.read();
-        for(size_t i=0; i<m_words ; i++)
-        {
-            r_xram_rsp_to_ixr_cmd_data[i] = r_xram_rsp_victim_data[i];
-        }
-        m_cpt_write_dirty++;
-
+        //r_xram_rsp_to_ixr_cmd_nline = r_xram_rsp_victim_nline.read();
+        r_xram_rsp_to_ixr_cmd_index = r_xram_rsp_trt_index.read();
+        /*for(size_t i=0; i<m_words ; i++)
+        {
+          r_xram_rsp_to_ixr_cmd_data[i] = r_xram_rsp_victim_data[i];
+        }*/
 #if (ODCCP_NON_INCLUSIVE == 0)
         // if victim is no coherent, we dont request a ixr command
@@ -4525,5 +4646,8 @@
 #endif
 
-        bool multi_req = !r_xram_rsp_victim_is_cnt.read() and r_xram_rsp_victim_inval.read();
+        m_cpt_write_dirty++;
+
+        bool multi_req = not r_xram_rsp_victim_is_cnt.read() and 
+          r_xram_rsp_victim_inval.read();
         bool not_last_multi_req = multi_req and (r_xram_rsp_victim_count.read() != 1);
 
@@ -4535,17 +4659,16 @@
 std::cout << "  <MEMC " << name() << " XRAM_RSP_WRITE_DIRTY>"
           << " Send the put request to IXR_CMD FSM"
-          << " / victim line = " << r_xram_rsp_victim_nline.read() << std::endl;
-#endif
-      }
-      break;
+          << " / address = " << r_xram_rsp_victim_nline.read()*m_words*4 << std::endl;
+#endif
+        }
+        break;
     }
     /////////////////////////
     case XRAM_RSP_HEAP_REQ:    // Get the lock to the HEAP
     {
-      if(r_alloc_heap_fsm.read() == ALLOC_HEAP_XRAM_RSP)
-      {
-        r_xram_rsp_fsm = XRAM_RSP_HEAP_ERASE;
-        m_cpt_xram_rsp_fsm_n_heap_lock++;
-      }
+        if(r_alloc_heap_fsm.read() == ALLOC_HEAP_XRAM_RSP)
+        {
+            r_xram_rsp_fsm = XRAM_RSP_HEAP_ERASE;
+        }
 
 #if DEBUG_MEMC_XRAM_RSP
@@ -4554,8 +4677,5 @@
           << " Requesting HEAP lock" << std::endl;
 #endif
-
-      m_cpt_xram_rsp_fsm_heap_lock++;
-
-      break;
+        break;
     }
     /////////////////////////
